#include <math.h>         // matematick funkce pro porovnn
#include "T_VYPOCT.H"     // hlavikov soubor tohoto C souboru

// funkce pouvan pouze v tomto souboru (nejsou exportovny jinam):

static unsigned long faktorial (long x);
static double mocnina (double x, unsigned n);
static double sinx(double x, unsigned presnost);
static double cosx(double x, unsigned presnost);
static double e_na_x (double x, unsigned presnost);
static double lnx(double x, unsigned presnost);

// definice funkc:

void dej_sin(double x, unsigned presnost, double *my_vysl, double *bc_vysl)
{
  *my_vysl = sinx(x, presnost);
  *bc_vysl = sin(x);
}

void dej_cos(double x, unsigned presnost, double *my_vysl, double *bc_vysl)
{
  *my_vysl = cosx(x, presnost);
  *bc_vysl = cos(x);
}

void dej_e_na_x(double x, unsigned presnost, double *my_vysl, double *bc_vysl)
{
  *my_vysl = e_na_x(x, presnost);
  *bc_vysl = exp(x);
}

void dej_lnx(double x, unsigned presnost, double *my_vysl, double *bc_vysl)
{
  *my_vysl = lnx(x, presnost);
  *bc_vysl = log(x);
}


unsigned long faktorial (long x)
{
  if (x <= 1) return (1);
  else return (x * faktorial(x-1));
}

double mocnina (double x, unsigned n)
{
  unsigned i;
  double vysl = 1.0;

  if (!n) return (1);
  else {
    for ( i = 1; i<=n; i++)
      vysl *= x;
    return (vysl);
  }
}
double sinx(double x, unsigned presnost)
{
  unsigned i, zb;
  double v, vysl = 0.0;
  unsigned long f;

  for (i = 1; i <= presnost; i++) { // stme prvky ady
    zb = i % 4;
    if ((zb == 1)||(zb == 3)) {
      f = faktorial(i);
      v = mocnina (x, i) / (double)f;
      if (zb == 1) vysl += v;
      else vysl -= v;
    }
  }
  return (vysl);
}

double cosx(double x, unsigned presnost)
{
  unsigned i, zb;
  double v, vysl = 0.0;
  unsigned long f;

  for (i = 0; i <= presnost; i++) {
    zb = i % 4;
    if ((zb == 0)||(zb == 2)) {
      f = faktorial(i);
      v = mocnina(x, i) / (double)f;
      if(!zb) vysl += v;
      else vysl -= v;
    }
  }
  return (vysl);
}

double e_na_x (double x, unsigned presnost)
{
  unsigned i;
  double v1, vysl = 0.0;
  unsigned long v2;

  for (i = 0; i <= presnost; i++) {
    v1 = mocnina (x, i);
    v2 = faktorial (i);
    vysl += v1 / v2;
  }
  return (vysl);
}

double lnx(double x, unsigned presnost)
{
  double x1=1-x;
  unsigned i;
  double v, vysl=0.0;

  for (i = 1; i <= presnost; i++) {
    v = mocnina(x1, i) / i;
    if (!(presnost % 2)) vysl -= v;
    else vysl += v;
  }
  return (vysl);
}

